// SAT_Text.cpp
// #@pg֐FTFeLXgp
#include "SharpAt.h"
#include <vector>
#include <string>

/*

E/dt/t??.dat ̃eLXgf[^ǂݍ݂\B
Et@Cԍ 0`99 ܂ŁB
E1xɎgt@C1܂ŁB
Eʏ̃ł͂ȂApstring֕ێB

gp၄
@TL0;@c@t0ԃt@CJF0`99܂
@TG0,x,y;@c@0sڂx,ÿʒuɕ\
  TB0;@c@ƃobt@stringp̈0sڂRs[
  TBSa;@c@ƃobt@̍ŏ $ ʒustringp̈asڂ}
  TBIa;@c@ƃobt@̍ŏ $ ʒuɕϐa̒l}
  TBGx,y;@c@ƃobt@̕Ax,ÿʒuɕ\
 */

// pstring
static std::vector<std::string> stringList;	// ǂݍ񂾑S
static std::string stringBuf; // ƃobt@p

// t@C當ǂݍ
static int LoadText(int n)
{
	// t@CJ
	char fname[320];
	sprintf(fname, "%sdt/t%d.dat", szExecDir, n);
	FILE* fp = fopen(fname, "rb");
	if (fp == nullptr)
		return -1;
	fpos_t fsize = 0;
	long fsizeb = fseek(fp, 0, SEEK_END);
	fgetpos(fp, &fsize);
	fseek(fp, fsizeb, SEEK_SET);
	// Sǂݍ
	fsize++;
	std::string buf((size_t)fsize, 0);
	char* str_all = (char*)buf.c_str();
	fread((void*)str_all, 1, (size_t)fsize, fp);
	// ĕێ
	stringList.clear();
	{
		size_t n = 0, max = (size_t)fsize;
		while (n < max)
		{
			size_t len = CSharpAt::Util_GetStrLen(str_all + n, '\n');
			if (len == 0) break;
			str_all[n + len] = 0;
			if (str_all[n + len-1] == '\r')
				str_all[n + len-1] = 0;
			std::string str(len,0);
			str = str_all + n;
			stringList.push_back(str);
			n += len+1;
		}
	}
	// I
	fclose(fp);
	return 0;	// OK
}

// List̕擾
static const char* GetString(int n)
{
	if (stringList.size() > (size_t)n)
		return stringList[n].c_str();
	return " ";
}

// string̎w蕶̌擾
//static int GetStringFindNum(const std::string& str, const char* s)
//{
//	int num = 0;
//	return num;
//}

//=======================================
// g֐ TFeLXgp
//=======================================
int CSharpAt::ExPr_Text(CSharpAt *ps,char *s)
{
	char* get = 0;
	int p[8];	// Al擾p
	int n;
	char c = *s ++;
	if (ps->GetNumExStr(s, n)==0)
	{
		// obt@H
		if (c == 'B')
		{
			c = *s++;
			// \H
			if (c == 'G')
			{
				if (ps->GetCommaNum(s, p, 2, &get) != 2)	// J}؂̐l擾
				{
					ps->ERR_PUT(ps->pos - 4);	// ERR
					return 0;
				}
				return DrawString(p[0], p[1], stringBuf.c_str());
			}
			// s擾H
			//if (c == 'K')
			//{
			//	return GetStringFindNum(stringBuf, "\n");
			//}
			if (ps->GetNumExStr(s, n)) // OK?
			{
				switch (c)
				{
				case 'S': // 
					{
						auto pos = Util_GetStrLen(stringBuf.c_str(), '$');
						if (pos >= stringBuf.length())
							return 0;
						stringBuf.erase(pos, 1);
						const char* str = GetString(n);
						stringBuf.insert(pos, str);
						// }̃oCgԂ
						return strlen(str);
					}
					return 0;
				case 'I': // 
					{
						auto pos = Util_GetStrLen(stringBuf.c_str(), '$');
						if (pos >= stringBuf.length())
							return 0;
						stringBuf.erase(pos, 1);
						const auto str = std::to_string(n);
						stringBuf.insert(pos, str);
						// }̃oCgԂ
						return strlen(str.c_str());
					}
					return 0;
				}
			}
		}
		ps->ERR_PUT(ps->pos - 4);
		return 0;
	}
	switch (c)
	{
	case 'L':	// ǂݍ
		{
			// 0-99܂
			if (n >= 0 && n <= 99)
			{
				if (LoadText(n) == -1)
				{
					MES_PUT("Error: Text Open = %d", n);
					ps->err = 1;
				}
			}
			else
			{
				MES_PUT("Error: Text File No Over = %d", n);
				ps->err = 1;
			}
		}
		if (ps->err == 0)
		{
			// 񐔂Ԃ
			return stringList.size();
		}
		return 0;
	case 'G':	// \
		{
			// W擾
			s+=2;
			if (ps->GetCommaNum(s, p, 2, &get) != 2)	// J}؂̐l擾
			{
				ps->ERR_PUT(ps->pos - 4);	// ERR
				return 0;
			}
			// ʒuړ		
			//s = get;
			// 쐬tHgŕ`
			return DrawString(p[0], p[1], GetString(n));
		}
		return 0;
	case 'B':	// obt@փx[Xݒ
		stringBuf = GetString(n);
		if (ps->err == 0 && stringBuf.size() > 0)
		{
			// ioCgjԂ
			return strlen(stringBuf.c_str());
		}
		return 0;
	default:
		// ̂܂܏o
		CSharpAt::MES_PUT(s);
		break;
	}
	return 0;
}
